//*******************************************************************
//
//  UNIT:     P L A S M A                        02.06.99,  21.07.99
//
//  true color plasma animation with Delphi 4
//
//-------------------------------------------------------------------
//
//  StartPlasma      start plasma demo
//  Plasma1          animated true color plasma demo 1
//
//*******************************************************************
unit plasma;

interface

function StartPlasma: string;
procedure Plasma1;

implementation

uses  Graphics, Graph;

var   sinTab, cosTab: array[0..255] of byte;

//*********************************************************
function StartPlasma: string;
begin
  result := 'rgb plasma demo';
  SetGraphMode (pf24Bit);
end;
//*********************************************************
procedure CalcSinusTab;
var   xi: word;
begin
  for xi := 0 to 255
  do begin
    sinTab[xi] := round (sin(pi*xi/128)*127)+127;
    cosTab[xi] := round (cos(pi*xi/128)*127)+127;
{    writeln (tst, xi:10, sinTab[xi]:10, cosTab[xi]:10);}
  end;
end;

const xr: byte = 0;    dxr = -1;
      yr: byte = 0;    dyr = -2;
      xg: byte = 0;    dxg = -3;
      yg: byte = 0;    dyg = +3;
      xb: byte = 0;    dxb = +2;
      yb: byte = 0;    dyb = +1;

//*********************************************************
// example of fast pixel drawing using tBitmap.ScanLine[..]
// with true color mode
//---------------------------------------------------------
procedure Plasma1;

var   xi, yi: integer;
      xr2, xg2, xb2: byte;
      yr2, yg2, yb2: byte;
      rgbPtr: ^byte;
begin
  xr := byte(xr + dxr);   yr := byte(yr + dyr);
  xg := byte(xg + dxg);   yg := byte(yg + dyg);
  xb := byte(xb + dxb);   yb := byte(yb + dyb);
  for yi := 0 to GetMaxY
  do begin
    xr2 := sinTab[(yi+yr) and $FF];
    yr2 := cosTab[(yi+sinTab[yr]) and $FF];
    xg2 := sinTab[(yi+yg) and $FF];
    yg2 := cosTab[(yi+sinTab[yg]) and $FF];
    xb2 := sinTab[(yi+yb) and $FF];
    yb2 := cosTab[(yi+sinTab[yb]) and $FF];
    rgbPtr := GetPixelPointer (0,yi);
    for xi := 0 to GetMaxX
    do begin
      rgbPtr^ := sinTab[byte(xi+xr2+yr2)];  inc (rgbPtr);
      rgbPtr^ := sinTab[byte(xi+xg2+yg2)];  inc (rgbPtr);
      rgbPtr^ := sinTab[byte(xi+xb2+yb2)];  inc (rgbPtr);
    end;
  end;
end;
//*********************************************************
procedure Plasma2;

var   xi, yi: integer;
      xr2, xg2, xb2: byte;
      yr2, yg2, yb2: byte;
      rgbPtr: ^byte;

begin
  xr := byte(xr + dxr);   yr := byte(yr + dyr);
  xg := byte(xg + dxg);   yg := byte(yg + dyg);
  xb := byte(xb + dxb);   yb := byte(yb + dyb);
  for yi := 0 to GetMaxY
  do begin
    xr2 := sinTab[(yi+xr)and $FF];   yr2 := cosTab[(xr2+yr) and $ff];
    xg2 := sinTab[(yi+xg)and $FF];   yg2 := cosTab[(xg2+yg) and $FF];
    xb2 := sinTab[(yi+xb)and $FF];   yb2 := cosTab[(xb2+yb) and $FF];
    rgbPtr := GetLinePointer (yi);
    for xi := 0 to GetMaxX
    do begin
      rgbPtr^ := cosTab[(xr2 + yr2 + xi) and $FF];  inc (rgbPtr);
      rgbPtr^ := cosTab[(xg2 + yg2 + xi) and $FF];  inc (rgbPtr);
      rgbPtr^ := cosTab[(xb2 + yb2 + xi) and $FF];  inc (rgbPtr);
    end;
  end;
end;

initialization
  CalcSinusTab;

end.
